<?php

define("DEBUG", "tinydata");

require_once __DIR__."/../vendor/autoload.php";

file_exists(__FILE__.".db") && unlink(__FILE__.".db");

use TinyData\DataStore;
use TinyData\Schema\DocumentSchema;

// Create a new datastore
$ds = new DataStore();

// Define the schema
$products = new DocumentSchema("products", 1);
$products->setIndexedField('/product/id*', 'productid');
$products->setIndexedField('/inventory/stock:INT');

// Map the schema
$ds->map($products);

$ds->products->insert([
    'product' => [ 'id'=>'PR1234', 'name'=>'Sample product'],
    'inventory' => [ 'stock'=>4 ],
]);

print_r($ds->products->findAll());
