<?php

require_once __DIR__."/../vendor/autoload.php";

use TinyData\DataStore;
use TinyData\Schema\TableSchema;

// Create a new datastore
$ds = new DataStore();

// Define the schema
$events = new TableSchema("events", 1);
$events->setColumn('timestamp', 'text');
$events->setColumn('message', 'text');

// Map the schema
// Can also be done as: $ds->events = $events;
$ds->map($events, "events");

// Insert an event
$ds->events->insert([
    'timestamp' => time(),
    'message' => "This is an event"
]);

// Fetch all events
print_r($ds->events->findAll());

print_r($ds->events->findOne(['rowid'=>1]));

$ds->events->deleteAll();