<?php

namespace NoccyLabs\TinyData\Collection;

use NoccyLabs\TinyData\DataStore;
use NoccyLabs\TinyData\Schema\Schema;
use PDO;

abstract class Collection
{
    protected $ds;

    protected $schema;

    protected $name;

    public function __construct(DataStore $ds, Schema $schema, $name)
    {
        $this->ds = $ds;
        $this->schema = $schema;
        $this->name = $name;
    }

    protected function matchToStatement(array $match)
    {
        $ret = [];
        foreach ($match as $col=>$value) {
            if (strpos($col,' ')===false) {
                $compstr = "==";
            } else {
                list($col,$comp) = explode(" ",$col,2);
                switch ($comp) {
                    case '>':
                    case 'gt':
                        $compstr='>';
                        break;
                    case '>=':
                    case 'gte':
                        $compstr='>=';
                        break;
                    case '==':
                    case 'eq':
                        $compstr='==';
                        break;
                    case '<':
                    case 'lt':
                        $compstr='<';
                        break;
                    case '<=':
                    case 'lte':
                        $compstr='<=';
                        break;
                }
            }
            $ret[] = "{$col}{$compstr}".$this->ds->quote($value);
        }

        return $ret;
    }

}
