<?php

namespace NoccyLabs\TinyData\Schema;

use NoccyLabs\TinyData\Collection\KeyValueCollection;

/**
 *
 *
 */
class KeyValueSchema extends Schema
{

    /**
     * Schema constructor
     *
     * @param string $name The schema name
     */
    public function __construct($name)
    {
        parent::__construct($name, 0);
        $this->setColumn("key","TEXT NOT NULL");
        $this->setColumn("value","TEXT");
        $this->setIndex("key", [ "key" ], "unique");
    }

    /**
     * {@inheritDoc}
     */
    public function getCollectionType()
    {
        return KeyValueCollection::class;
    }

}
