<?php

namespace NoccyLabs\TinyData\Schema;

use NoccyLabs\TinyData\DataStore;

abstract class Schema
{
    /** @var string The schema name */
    public $name;
    /** @var int The version of the schema */
    public $version;
    /** @var array Column definitions */
    public $definition = [];
    /** @var array Indexes */
    public $indexes = [];

    public function __construct($name, $version)
    {
        $this->name = $name;
        $this->version = $version;
    }

    public function setColumn($name, $definition="TEXT")
    {
        $this->definition[$name] = $definition;
        return $this;
    }

    public function setIndex($name, array $columns, $unique=false)
    {
        $this->indexes['idx_'.$this->name.'_'.$name] = (object)[
            'columns' => $columns,
            'unique' => (bool)$unique
        ];
        return $this;
    }

    abstract public function getCollectionType();

}
