<?php

namespace NoccyLabs\TinyData\Schema;

use NoccyLabs\TinyData\DataStore;
use NoccyLabs\TinyData\Collection\TableCollection;

/**
 *
 *
 */
class TableSchema extends Schema
{
    /**
     * Schema constructor
     *
     * @param string $name The schema name
     * @param int $version The schema version
     * @param array $definition Schema definition
     */
    public function __construct($name='table', $version=1, array $definition=[])
    {
        parent::__construct($name, $version);
        foreach ($definition as $k=>$def) {
            if (is_integer($k)) {
                $k = $def;
                $def = null;
            }
            if ($k[0]=='!') {
                // unique index
                $_k = substr($k,1);
                $this->setColumn($_k, $def);
                $this->setIndex($_k, [ $_k ], true);
            } else {
                $this->setColumn($k, $def);
            }
        }
    }

    /**
     * {@inheritDoc}
     */
    public function getCollectionType()
    {
        return TableCollection::class;
    }


}
